#![no_std]
#[macro_use]
extern crate crypto_tests;
extern crate generic_array;
extern crate sha3;

use crypto_tests::hash::{Test, main_test, variable_test};

#[test]
fn keccak_224() {
    let tests = new_tests!("keccak_224/test1");
    main_test::<sha3::Keccak224>(&tests);
}

#[test]
fn keccak_256() {
    let tests =
        new_tests!("keccak_256/test1", "keccak_256/test2", "keccak_256/test3");
    main_test::<sha3::Keccak256>(&tests);
}

#[test]
fn keccak_384() {
    let tests = new_tests!("keccak_384/test1");
    main_test::<sha3::Keccak384>(&tests);
}

#[test]
fn keccak_512() {
    let tests = new_tests!("keccak_512/test1");
    main_test::<sha3::Keccak512>(&tests);
}

#[test]
fn sha3_224() {
    let tests = new_tests!("sha3_224/test1",
                           "sha3_224/test2",
                           "sha3_224/test3",
                           "sha3_224/test4",
                           "sha3_224/test5",
                           "sha3_224/test6",
                           "sha3_224/test7",
                           "sha3_224/test8",
                           "sha3_224/test9",
                           "sha3_224/test10",
                           "sha3_224/test11",
                           "sha3_224/test12",
                           "sha3_224/test13",
                           "sha3_224/test14",
                           "sha3_224/test15",
                           "sha3_224/test16",
                           "sha3_224/test17",
                           "sha3_224/test18",
                           "sha3_224/test19",
                           "sha3_224/test20",
                           "sha3_224/test21",
                           "sha3_224/test22",
                           "sha3_224/test23",
                           "sha3_224/test24",
                           "sha3_224/test25",
                           "sha3_224/test26",
                           "sha3_224/test27",
                           "sha3_224/test28",
                           "sha3_224/test29",
                           "sha3_224/test30",
                           "sha3_224/test31",
                           "sha3_224/test32",
                           "sha3_224/test33",
                           "sha3_224/test34",
                           "sha3_224/test35",
                           "sha3_224/test36",
                           "sha3_224/test37",
                           "sha3_224/test38",
                           "sha3_224/test39",
                           "sha3_224/test40",
                           "sha3_224/test41",
                           "sha3_224/test42",
                           "sha3_224/test43",
                           "sha3_224/test44",
                           "sha3_224/test45",
                           "sha3_224/test46",
                           "sha3_224/test47",
                           "sha3_224/test48",
                           "sha3_224/test49",
                           "sha3_224/test50",
                           "sha3_224/test51",
                           "sha3_224/test52",
                           "sha3_224/test53",
                           "sha3_224/test54",
                           "sha3_224/test55",
                           "sha3_224/test56",
                           "sha3_224/test57",
                           "sha3_224/test58",
                           "sha3_224/test59",
                           "sha3_224/test60",
                           "sha3_224/test61",
                           "sha3_224/test62",
                           "sha3_224/test63",
                           "sha3_224/test64",
                           "sha3_224/test65",
                           "sha3_224/test66",
                           "sha3_224/test67",
                           "sha3_224/test68",
                           "sha3_224/test69",
                           "sha3_224/test70",
                           "sha3_224/test71",
                           "sha3_224/test72",
                           "sha3_224/test73",
                           "sha3_224/test74",
                           "sha3_224/test75",
                           "sha3_224/test76",
                           "sha3_224/test77",
                           "sha3_224/test78",
                           "sha3_224/test79",
                           "sha3_224/test80",
                           "sha3_224/test81",
                           "sha3_224/test82",
                           "sha3_224/test83",
                           "sha3_224/test84",
                           "sha3_224/test85",
                           "sha3_224/test86",
                           "sha3_224/test87",
                           "sha3_224/test88",
                           "sha3_224/test89",
                           "sha3_224/test90",
                           "sha3_224/test91",
                           "sha3_224/test92",
                           "sha3_224/test93",
                           "sha3_224/test94",
                           "sha3_224/test95",
                           "sha3_224/test96",
                           "sha3_224/test97",
                           "sha3_224/test98",
                           "sha3_224/test99",
                           "sha3_224/test100",
                           "sha3_224/test101",
                           "sha3_224/test102",
                           "sha3_224/test103",
                           "sha3_224/test104",
                           "sha3_224/test105",
                           "sha3_224/test106",
                           "sha3_224/test107",
                           "sha3_224/test108",
                           "sha3_224/test109",
                           "sha3_224/test110",
                           "sha3_224/test111",
                           "sha3_224/test112",
                           "sha3_224/test113",
                           "sha3_224/test114",
                           "sha3_224/test115",
                           "sha3_224/test116",
                           "sha3_224/test117",
                           "sha3_224/test118",
                           "sha3_224/test119",
                           "sha3_224/test120",
                           "sha3_224/test121",
                           "sha3_224/test122",
                           "sha3_224/test123",
                           "sha3_224/test124",
                           "sha3_224/test125",
                           "sha3_224/test126",
                           "sha3_224/test127",
                           "sha3_224/test128",
                           "sha3_224/test129",
                           "sha3_224/test130",
                           "sha3_224/test131",
                           "sha3_224/test132",
                           "sha3_224/test133",
                           "sha3_224/test134",
                           "sha3_224/test135",
                           "sha3_224/test136",
                           "sha3_224/test137",
                           "sha3_224/test138",
                           "sha3_224/test139",
                           "sha3_224/test140",
                           "sha3_224/test141",
                           "sha3_224/test142",
                           "sha3_224/test143",
                           "sha3_224/test144",
                           "sha3_224/test145",
                           "sha3_224/test146",
                           "sha3_224/test147",
                           "sha3_224/test148",
                           "sha3_224/test149",
                           "sha3_224/test150",
                           "sha3_224/test151",
                           "sha3_224/test152",
                           "sha3_224/test153",
                           "sha3_224/test154",
                           "sha3_224/test155",
                           "sha3_224/test156",
                           "sha3_224/test157",
                           "sha3_224/test158",
                           "sha3_224/test159",
                           "sha3_224/test160",
                           "sha3_224/test161",
                           "sha3_224/test162",
                           "sha3_224/test163",
                           "sha3_224/test164",
                           "sha3_224/test165",
                           "sha3_224/test166",
                           "sha3_224/test167",
                           "sha3_224/test168",
                           "sha3_224/test169",
                           "sha3_224/test170",
                           "sha3_224/test171",
                           "sha3_224/test172",
                           "sha3_224/test173",
                           "sha3_224/test174",
                           "sha3_224/test175",
                           "sha3_224/test176",
                           "sha3_224/test177",
                           "sha3_224/test178",
                           "sha3_224/test179",
                           "sha3_224/test180",
                           "sha3_224/test181",
                           "sha3_224/test182",
                           "sha3_224/test183",
                           "sha3_224/test184",
                           "sha3_224/test185",
                           "sha3_224/test186",
                           "sha3_224/test187",
                           "sha3_224/test188",
                           "sha3_224/test189",
                           "sha3_224/test190",
                           "sha3_224/test191",
                           "sha3_224/test192",
                           "sha3_224/test193",
                           "sha3_224/test194",
                           "sha3_224/test195",
                           "sha3_224/test196",
                           "sha3_224/test197",
                           "sha3_224/test198",
                           "sha3_224/test199",
                           "sha3_224/test200",
                           "sha3_224/test201",
                           "sha3_224/test202",
                           "sha3_224/test203",
                           "sha3_224/test204",
                           "sha3_224/test205",
                           "sha3_224/test206",
                           "sha3_224/test207",
                           "sha3_224/test208",
                           "sha3_224/test209",
                           "sha3_224/test210",
                           "sha3_224/test211",
                           "sha3_224/test212",
                           "sha3_224/test213",
                           "sha3_224/test214",
                           "sha3_224/test215",
                           "sha3_224/test216",
                           "sha3_224/test217",
                           "sha3_224/test218",
                           "sha3_224/test219",
                           "sha3_224/test220",
                           "sha3_224/test221",
                           "sha3_224/test222",
                           "sha3_224/test223",
                           "sha3_224/test224",
                           "sha3_224/test225",
                           "sha3_224/test226",
                           "sha3_224/test227",
                           "sha3_224/test228",
                           "sha3_224/test229",
                           "sha3_224/test230",
                           "sha3_224/test231",
                           "sha3_224/test232",
                           "sha3_224/test233",
                           "sha3_224/test234",
                           "sha3_224/test235",
                           "sha3_224/test236",
                           "sha3_224/test237",
                           "sha3_224/test238",
                           "sha3_224/test239",
                           "sha3_224/test240",
                           "sha3_224/test241",
                           "sha3_224/test242",
                           "sha3_224/test243",
                           "sha3_224/test244",
                           "sha3_224/test245",
                           "sha3_224/test246",
                           "sha3_224/test247",
                           "sha3_224/test248",
                           "sha3_224/test249",
                           "sha3_224/test250",
                           "sha3_224/test251",
                           "sha3_224/test252",
                           "sha3_224/test253",
                           "sha3_224/test254",
                           "sha3_224/test255",
                           "sha3_224/test256");
    main_test::<sha3::Sha3_224>(&tests);
}

#[test]
fn sha3_256() {
    let tests = new_tests!("sha3_256/test1",
                           "sha3_256/test2",
                           "sha3_256/test3",
                           "sha3_256/test4",
                           "sha3_256/test5",
                           "sha3_256/test6",
                           "sha3_256/test7",
                           "sha3_256/test8",
                           "sha3_256/test9",
                           "sha3_256/test10",
                           "sha3_256/test11",
                           "sha3_256/test12",
                           "sha3_256/test13",
                           "sha3_256/test14",
                           "sha3_256/test15",
                           "sha3_256/test16",
                           "sha3_256/test17",
                           "sha3_256/test18",
                           "sha3_256/test19",
                           "sha3_256/test20",
                           "sha3_256/test21",
                           "sha3_256/test22",
                           "sha3_256/test23",
                           "sha3_256/test24",
                           "sha3_256/test25",
                           "sha3_256/test26",
                           "sha3_256/test27",
                           "sha3_256/test28",
                           "sha3_256/test29",
                           "sha3_256/test30",
                           "sha3_256/test31",
                           "sha3_256/test32",
                           "sha3_256/test33",
                           "sha3_256/test34",
                           "sha3_256/test35",
                           "sha3_256/test36",
                           "sha3_256/test37",
                           "sha3_256/test38",
                           "sha3_256/test39",
                           "sha3_256/test40",
                           "sha3_256/test41",
                           "sha3_256/test42",
                           "sha3_256/test43",
                           "sha3_256/test44",
                           "sha3_256/test45",
                           "sha3_256/test46",
                           "sha3_256/test47",
                           "sha3_256/test48",
                           "sha3_256/test49",
                           "sha3_256/test50",
                           "sha3_256/test51",
                           "sha3_256/test52",
                           "sha3_256/test53",
                           "sha3_256/test54",
                           "sha3_256/test55",
                           "sha3_256/test56",
                           "sha3_256/test57",
                           "sha3_256/test58",
                           "sha3_256/test59",
                           "sha3_256/test60",
                           "sha3_256/test61",
                           "sha3_256/test62",
                           "sha3_256/test63",
                           "sha3_256/test64",
                           "sha3_256/test65",
                           "sha3_256/test66",
                           "sha3_256/test67",
                           "sha3_256/test68",
                           "sha3_256/test69",
                           "sha3_256/test70",
                           "sha3_256/test71",
                           "sha3_256/test72",
                           "sha3_256/test73",
                           "sha3_256/test74",
                           "sha3_256/test75",
                           "sha3_256/test76",
                           "sha3_256/test77",
                           "sha3_256/test78",
                           "sha3_256/test79",
                           "sha3_256/test80",
                           "sha3_256/test81",
                           "sha3_256/test82",
                           "sha3_256/test83",
                           "sha3_256/test84",
                           "sha3_256/test85",
                           "sha3_256/test86",
                           "sha3_256/test87",
                           "sha3_256/test88",
                           "sha3_256/test89",
                           "sha3_256/test90",
                           "sha3_256/test91",
                           "sha3_256/test92",
                           "sha3_256/test93",
                           "sha3_256/test94",
                           "sha3_256/test95",
                           "sha3_256/test96",
                           "sha3_256/test97",
                           "sha3_256/test98",
                           "sha3_256/test99",
                           "sha3_256/test100",
                           "sha3_256/test101",
                           "sha3_256/test102",
                           "sha3_256/test103",
                           "sha3_256/test104",
                           "sha3_256/test105",
                           "sha3_256/test106",
                           "sha3_256/test107",
                           "sha3_256/test108",
                           "sha3_256/test109",
                           "sha3_256/test110",
                           "sha3_256/test111",
                           "sha3_256/test112",
                           "sha3_256/test113",
                           "sha3_256/test114",
                           "sha3_256/test115",
                           "sha3_256/test116",
                           "sha3_256/test117",
                           "sha3_256/test118",
                           "sha3_256/test119",
                           "sha3_256/test120",
                           "sha3_256/test121",
                           "sha3_256/test122",
                           "sha3_256/test123",
                           "sha3_256/test124",
                           "sha3_256/test125",
                           "sha3_256/test126",
                           "sha3_256/test127",
                           "sha3_256/test128",
                           "sha3_256/test129",
                           "sha3_256/test130",
                           "sha3_256/test131",
                           "sha3_256/test132",
                           "sha3_256/test133",
                           "sha3_256/test134",
                           "sha3_256/test135",
                           "sha3_256/test136",
                           "sha3_256/test137",
                           "sha3_256/test138",
                           "sha3_256/test139",
                           "sha3_256/test140",
                           "sha3_256/test141",
                           "sha3_256/test142",
                           "sha3_256/test143",
                           "sha3_256/test144",
                           "sha3_256/test145",
                           "sha3_256/test146",
                           "sha3_256/test147",
                           "sha3_256/test148",
                           "sha3_256/test149",
                           "sha3_256/test150",
                           "sha3_256/test151",
                           "sha3_256/test152",
                           "sha3_256/test153",
                           "sha3_256/test154",
                           "sha3_256/test155",
                           "sha3_256/test156",
                           "sha3_256/test157",
                           "sha3_256/test158",
                           "sha3_256/test159",
                           "sha3_256/test160",
                           "sha3_256/test161",
                           "sha3_256/test162",
                           "sha3_256/test163",
                           "sha3_256/test164",
                           "sha3_256/test165",
                           "sha3_256/test166",
                           "sha3_256/test167",
                           "sha3_256/test168",
                           "sha3_256/test169",
                           "sha3_256/test170",
                           "sha3_256/test171",
                           "sha3_256/test172",
                           "sha3_256/test173",
                           "sha3_256/test174",
                           "sha3_256/test175",
                           "sha3_256/test176",
                           "sha3_256/test177",
                           "sha3_256/test178",
                           "sha3_256/test179",
                           "sha3_256/test180",
                           "sha3_256/test181",
                           "sha3_256/test182",
                           "sha3_256/test183",
                           "sha3_256/test184",
                           "sha3_256/test185",
                           "sha3_256/test186",
                           "sha3_256/test187",
                           "sha3_256/test188",
                           "sha3_256/test189",
                           "sha3_256/test190",
                           "sha3_256/test191",
                           "sha3_256/test192",
                           "sha3_256/test193",
                           "sha3_256/test194",
                           "sha3_256/test195",
                           "sha3_256/test196",
                           "sha3_256/test197",
                           "sha3_256/test198",
                           "sha3_256/test199",
                           "sha3_256/test200",
                           "sha3_256/test201",
                           "sha3_256/test202",
                           "sha3_256/test203",
                           "sha3_256/test204",
                           "sha3_256/test205",
                           "sha3_256/test206",
                           "sha3_256/test207",
                           "sha3_256/test208",
                           "sha3_256/test209",
                           "sha3_256/test210",
                           "sha3_256/test211",
                           "sha3_256/test212",
                           "sha3_256/test213",
                           "sha3_256/test214",
                           "sha3_256/test215",
                           "sha3_256/test216",
                           "sha3_256/test217",
                           "sha3_256/test218",
                           "sha3_256/test219",
                           "sha3_256/test220",
                           "sha3_256/test221",
                           "sha3_256/test222",
                           "sha3_256/test223",
                           "sha3_256/test224",
                           "sha3_256/test225",
                           "sha3_256/test226",
                           "sha3_256/test227",
                           "sha3_256/test228",
                           "sha3_256/test229",
                           "sha3_256/test230",
                           "sha3_256/test231",
                           "sha3_256/test232",
                           "sha3_256/test233",
                           "sha3_256/test234",
                           "sha3_256/test235",
                           "sha3_256/test236",
                           "sha3_256/test237",
                           "sha3_256/test238",
                           "sha3_256/test239",
                           "sha3_256/test240",
                           "sha3_256/test241",
                           "sha3_256/test242",
                           "sha3_256/test243",
                           "sha3_256/test244",
                           "sha3_256/test245",
                           "sha3_256/test246",
                           "sha3_256/test247",
                           "sha3_256/test248",
                           "sha3_256/test249",
                           "sha3_256/test250",
                           "sha3_256/test251",
                           "sha3_256/test252",
                           "sha3_256/test253",
                           "sha3_256/test254",
                           "sha3_256/test255",
                           "sha3_256/test256");
    main_test::<sha3::Sha3_256>(&tests);
}

#[test]
fn sha3_384() {
    let tests = new_tests!("sha3_384/test1",
                           "sha3_384/test2",
                           "sha3_384/test3",
                           "sha3_384/test4",
                           "sha3_384/test5",
                           "sha3_384/test6",
                           "sha3_384/test7",
                           "sha3_384/test8",
                           "sha3_384/test9",
                           "sha3_384/test10",
                           "sha3_384/test11",
                           "sha3_384/test12",
                           "sha3_384/test13",
                           "sha3_384/test14",
                           "sha3_384/test15",
                           "sha3_384/test16",
                           "sha3_384/test17",
                           "sha3_384/test18",
                           "sha3_384/test19",
                           "sha3_384/test20",
                           "sha3_384/test21",
                           "sha3_384/test22",
                           "sha3_384/test23",
                           "sha3_384/test24",
                           "sha3_384/test25",
                           "sha3_384/test26",
                           "sha3_384/test27",
                           "sha3_384/test28",
                           "sha3_384/test29",
                           "sha3_384/test30",
                           "sha3_384/test31",
                           "sha3_384/test32",
                           "sha3_384/test33",
                           "sha3_384/test34",
                           "sha3_384/test35",
                           "sha3_384/test36",
                           "sha3_384/test37",
                           "sha3_384/test38",
                           "sha3_384/test39",
                           "sha3_384/test40",
                           "sha3_384/test41",
                           "sha3_384/test42",
                           "sha3_384/test43",
                           "sha3_384/test44",
                           "sha3_384/test45",
                           "sha3_384/test46",
                           "sha3_384/test47",
                           "sha3_384/test48",
                           "sha3_384/test49",
                           "sha3_384/test50",
                           "sha3_384/test51",
                           "sha3_384/test52",
                           "sha3_384/test53",
                           "sha3_384/test54",
                           "sha3_384/test55",
                           "sha3_384/test56",
                           "sha3_384/test57",
                           "sha3_384/test58",
                           "sha3_384/test59",
                           "sha3_384/test60",
                           "sha3_384/test61",
                           "sha3_384/test62",
                           "sha3_384/test63",
                           "sha3_384/test64",
                           "sha3_384/test65",
                           "sha3_384/test66",
                           "sha3_384/test67",
                           "sha3_384/test68",
                           "sha3_384/test69",
                           "sha3_384/test70",
                           "sha3_384/test71",
                           "sha3_384/test72",
                           "sha3_384/test73",
                           "sha3_384/test74",
                           "sha3_384/test75",
                           "sha3_384/test76",
                           "sha3_384/test77",
                           "sha3_384/test78",
                           "sha3_384/test79",
                           "sha3_384/test80",
                           "sha3_384/test81",
                           "sha3_384/test82",
                           "sha3_384/test83",
                           "sha3_384/test84",
                           "sha3_384/test85",
                           "sha3_384/test86",
                           "sha3_384/test87",
                           "sha3_384/test88",
                           "sha3_384/test89",
                           "sha3_384/test90",
                           "sha3_384/test91",
                           "sha3_384/test92",
                           "sha3_384/test93",
                           "sha3_384/test94",
                           "sha3_384/test95",
                           "sha3_384/test96",
                           "sha3_384/test97",
                           "sha3_384/test98",
                           "sha3_384/test99",
                           "sha3_384/test100",
                           "sha3_384/test101",
                           "sha3_384/test102",
                           "sha3_384/test103",
                           "sha3_384/test104",
                           "sha3_384/test105",
                           "sha3_384/test106",
                           "sha3_384/test107",
                           "sha3_384/test108",
                           "sha3_384/test109",
                           "sha3_384/test110",
                           "sha3_384/test111",
                           "sha3_384/test112",
                           "sha3_384/test113",
                           "sha3_384/test114",
                           "sha3_384/test115",
                           "sha3_384/test116",
                           "sha3_384/test117",
                           "sha3_384/test118",
                           "sha3_384/test119",
                           "sha3_384/test120",
                           "sha3_384/test121",
                           "sha3_384/test122",
                           "sha3_384/test123",
                           "sha3_384/test124",
                           "sha3_384/test125",
                           "sha3_384/test126",
                           "sha3_384/test127",
                           "sha3_384/test128",
                           "sha3_384/test129",
                           "sha3_384/test130",
                           "sha3_384/test131",
                           "sha3_384/test132",
                           "sha3_384/test133",
                           "sha3_384/test134",
                           "sha3_384/test135",
                           "sha3_384/test136",
                           "sha3_384/test137",
                           "sha3_384/test138",
                           "sha3_384/test139",
                           "sha3_384/test140",
                           "sha3_384/test141",
                           "sha3_384/test142",
                           "sha3_384/test143",
                           "sha3_384/test144",
                           "sha3_384/test145",
                           "sha3_384/test146",
                           "sha3_384/test147",
                           "sha3_384/test148",
                           "sha3_384/test149",
                           "sha3_384/test150",
                           "sha3_384/test151",
                           "sha3_384/test152",
                           "sha3_384/test153",
                           "sha3_384/test154",
                           "sha3_384/test155",
                           "sha3_384/test156",
                           "sha3_384/test157",
                           "sha3_384/test158",
                           "sha3_384/test159",
                           "sha3_384/test160",
                           "sha3_384/test161",
                           "sha3_384/test162",
                           "sha3_384/test163",
                           "sha3_384/test164",
                           "sha3_384/test165",
                           "sha3_384/test166",
                           "sha3_384/test167",
                           "sha3_384/test168",
                           "sha3_384/test169",
                           "sha3_384/test170",
                           "sha3_384/test171",
                           "sha3_384/test172",
                           "sha3_384/test173",
                           "sha3_384/test174",
                           "sha3_384/test175",
                           "sha3_384/test176",
                           "sha3_384/test177",
                           "sha3_384/test178",
                           "sha3_384/test179",
                           "sha3_384/test180",
                           "sha3_384/test181",
                           "sha3_384/test182",
                           "sha3_384/test183",
                           "sha3_384/test184",
                           "sha3_384/test185",
                           "sha3_384/test186",
                           "sha3_384/test187",
                           "sha3_384/test188",
                           "sha3_384/test189",
                           "sha3_384/test190",
                           "sha3_384/test191",
                           "sha3_384/test192",
                           "sha3_384/test193",
                           "sha3_384/test194",
                           "sha3_384/test195",
                           "sha3_384/test196",
                           "sha3_384/test197",
                           "sha3_384/test198",
                           "sha3_384/test199",
                           "sha3_384/test200",
                           "sha3_384/test201",
                           "sha3_384/test202",
                           "sha3_384/test203",
                           "sha3_384/test204",
                           "sha3_384/test205",
                           "sha3_384/test206",
                           "sha3_384/test207",
                           "sha3_384/test208",
                           "sha3_384/test209",
                           "sha3_384/test210",
                           "sha3_384/test211",
                           "sha3_384/test212",
                           "sha3_384/test213",
                           "sha3_384/test214",
                           "sha3_384/test215",
                           "sha3_384/test216",
                           "sha3_384/test217",
                           "sha3_384/test218",
                           "sha3_384/test219",
                           "sha3_384/test220",
                           "sha3_384/test221",
                           "sha3_384/test222",
                           "sha3_384/test223",
                           "sha3_384/test224",
                           "sha3_384/test225",
                           "sha3_384/test226",
                           "sha3_384/test227",
                           "sha3_384/test228",
                           "sha3_384/test229",
                           "sha3_384/test230",
                           "sha3_384/test231",
                           "sha3_384/test232",
                           "sha3_384/test233",
                           "sha3_384/test234",
                           "sha3_384/test235",
                           "sha3_384/test236",
                           "sha3_384/test237",
                           "sha3_384/test238",
                           "sha3_384/test239",
                           "sha3_384/test240",
                           "sha3_384/test241",
                           "sha3_384/test242",
                           "sha3_384/test243",
                           "sha3_384/test244",
                           "sha3_384/test245",
                           "sha3_384/test246",
                           "sha3_384/test247",
                           "sha3_384/test248",
                           "sha3_384/test249",
                           "sha3_384/test250",
                           "sha3_384/test251",
                           "sha3_384/test252",
                           "sha3_384/test253",
                           "sha3_384/test254",
                           "sha3_384/test255");
    main_test::<sha3::Sha3_384>(&tests);
}

#[test]
fn sha3_512() {
    let tests = new_tests!("sha3_512/test1",
                           "sha3_512/test2",
                           "sha3_512/test3",
                           "sha3_512/test4",
                           "sha3_512/test5",
                           "sha3_512/test6",
                           "sha3_512/test7",
                           "sha3_512/test8",
                           "sha3_512/test9",
                           "sha3_512/test10",
                           "sha3_512/test11",
                           "sha3_512/test12",
                           "sha3_512/test13",
                           "sha3_512/test14",
                           "sha3_512/test15",
                           "sha3_512/test16",
                           "sha3_512/test17",
                           "sha3_512/test18",
                           "sha3_512/test19",
                           "sha3_512/test20",
                           "sha3_512/test21",
                           "sha3_512/test22",
                           "sha3_512/test23",
                           "sha3_512/test24",
                           "sha3_512/test25",
                           "sha3_512/test26",
                           "sha3_512/test27",
                           "sha3_512/test28",
                           "sha3_512/test29",
                           "sha3_512/test30",
                           "sha3_512/test31",
                           "sha3_512/test32",
                           "sha3_512/test33",
                           "sha3_512/test34",
                           "sha3_512/test35",
                           "sha3_512/test36",
                           "sha3_512/test37",
                           "sha3_512/test38",
                           "sha3_512/test39",
                           "sha3_512/test40",
                           "sha3_512/test41",
                           "sha3_512/test42",
                           "sha3_512/test43",
                           "sha3_512/test44",
                           "sha3_512/test45",
                           "sha3_512/test46",
                           "sha3_512/test47",
                           "sha3_512/test48",
                           "sha3_512/test49",
                           "sha3_512/test50",
                           "sha3_512/test51",
                           "sha3_512/test52",
                           "sha3_512/test53",
                           "sha3_512/test54",
                           "sha3_512/test55",
                           "sha3_512/test56",
                           "sha3_512/test57",
                           "sha3_512/test58",
                           "sha3_512/test59",
                           "sha3_512/test60",
                           "sha3_512/test61",
                           "sha3_512/test62",
                           "sha3_512/test63",
                           "sha3_512/test64",
                           "sha3_512/test65",
                           "sha3_512/test66",
                           "sha3_512/test67",
                           "sha3_512/test68",
                           "sha3_512/test69",
                           "sha3_512/test70",
                           "sha3_512/test71",
                           "sha3_512/test72",
                           "sha3_512/test73",
                           "sha3_512/test74",
                           "sha3_512/test75",
                           "sha3_512/test76",
                           "sha3_512/test77",
                           "sha3_512/test78",
                           "sha3_512/test79",
                           "sha3_512/test80",
                           "sha3_512/test81",
                           "sha3_512/test82",
                           "sha3_512/test83",
                           "sha3_512/test84",
                           "sha3_512/test85",
                           "sha3_512/test86",
                           "sha3_512/test87",
                           "sha3_512/test88",
                           "sha3_512/test89",
                           "sha3_512/test90",
                           "sha3_512/test91",
                           "sha3_512/test92",
                           "sha3_512/test93",
                           "sha3_512/test94",
                           "sha3_512/test95",
                           "sha3_512/test96",
                           "sha3_512/test97",
                           "sha3_512/test98",
                           "sha3_512/test99",
                           "sha3_512/test100",
                           "sha3_512/test101",
                           "sha3_512/test102",
                           "sha3_512/test103",
                           "sha3_512/test104",
                           "sha3_512/test105",
                           "sha3_512/test106",
                           "sha3_512/test107",
                           "sha3_512/test108",
                           "sha3_512/test109",
                           "sha3_512/test110",
                           "sha3_512/test111",
                           "sha3_512/test112",
                           "sha3_512/test113",
                           "sha3_512/test114",
                           "sha3_512/test115",
                           "sha3_512/test116",
                           "sha3_512/test117",
                           "sha3_512/test118",
                           "sha3_512/test119",
                           "sha3_512/test120",
                           "sha3_512/test121",
                           "sha3_512/test122",
                           "sha3_512/test123",
                           "sha3_512/test124",
                           "sha3_512/test125",
                           "sha3_512/test126",
                           "sha3_512/test127",
                           "sha3_512/test128",
                           "sha3_512/test129",
                           "sha3_512/test130",
                           "sha3_512/test131",
                           "sha3_512/test132",
                           "sha3_512/test133",
                           "sha3_512/test134",
                           "sha3_512/test135",
                           "sha3_512/test136",
                           "sha3_512/test137",
                           "sha3_512/test138",
                           "sha3_512/test139",
                           "sha3_512/test140",
                           "sha3_512/test141",
                           "sha3_512/test142",
                           "sha3_512/test143",
                           "sha3_512/test144",
                           "sha3_512/test145",
                           "sha3_512/test146",
                           "sha3_512/test147",
                           "sha3_512/test148",
                           "sha3_512/test149",
                           "sha3_512/test150",
                           "sha3_512/test151",
                           "sha3_512/test152",
                           "sha3_512/test153",
                           "sha3_512/test154",
                           "sha3_512/test155",
                           "sha3_512/test156",
                           "sha3_512/test157",
                           "sha3_512/test158",
                           "sha3_512/test159",
                           "sha3_512/test160",
                           "sha3_512/test161",
                           "sha3_512/test162",
                           "sha3_512/test163",
                           "sha3_512/test164",
                           "sha3_512/test165",
                           "sha3_512/test166",
                           "sha3_512/test167",
                           "sha3_512/test168",
                           "sha3_512/test169",
                           "sha3_512/test170",
                           "sha3_512/test171",
                           "sha3_512/test172",
                           "sha3_512/test173",
                           "sha3_512/test174",
                           "sha3_512/test175",
                           "sha3_512/test176",
                           "sha3_512/test177",
                           "sha3_512/test178",
                           "sha3_512/test179",
                           "sha3_512/test180",
                           "sha3_512/test181",
                           "sha3_512/test182",
                           "sha3_512/test183",
                           "sha3_512/test184",
                           "sha3_512/test185",
                           "sha3_512/test186",
                           "sha3_512/test187",
                           "sha3_512/test188",
                           "sha3_512/test189",
                           "sha3_512/test190",
                           "sha3_512/test191",
                           "sha3_512/test192",
                           "sha3_512/test193",
                           "sha3_512/test194",
                           "sha3_512/test195",
                           "sha3_512/test196",
                           "sha3_512/test197",
                           "sha3_512/test198",
                           "sha3_512/test199",
                           "sha3_512/test200",
                           "sha3_512/test201",
                           "sha3_512/test202",
                           "sha3_512/test203",
                           "sha3_512/test204",
                           "sha3_512/test205",
                           "sha3_512/test206",
                           "sha3_512/test207",
                           "sha3_512/test208",
                           "sha3_512/test209",
                           "sha3_512/test210",
                           "sha3_512/test211",
                           "sha3_512/test212",
                           "sha3_512/test213",
                           "sha3_512/test214",
                           "sha3_512/test215",
                           "sha3_512/test216",
                           "sha3_512/test217",
                           "sha3_512/test218",
                           "sha3_512/test219",
                           "sha3_512/test220",
                           "sha3_512/test221",
                           "sha3_512/test222",
                           "sha3_512/test223",
                           "sha3_512/test224",
                           "sha3_512/test225",
                           "sha3_512/test226",
                           "sha3_512/test227",
                           "sha3_512/test228",
                           "sha3_512/test229",
                           "sha3_512/test230",
                           "sha3_512/test231",
                           "sha3_512/test232",
                           "sha3_512/test233",
                           "sha3_512/test234",
                           "sha3_512/test235",
                           "sha3_512/test236",
                           "sha3_512/test237",
                           "sha3_512/test238",
                           "sha3_512/test239",
                           "sha3_512/test240",
                           "sha3_512/test241",
                           "sha3_512/test242",
                           "sha3_512/test243",
                           "sha3_512/test244",
                           "sha3_512/test245",
                           "sha3_512/test246",
                           "sha3_512/test247",
                           "sha3_512/test248",
                           "sha3_512/test249",
                           "sha3_512/test250",
                           "sha3_512/test251",
                           "sha3_512/test252",
                           "sha3_512/test253",
                           "sha3_512/test254",
                           "sha3_512/test255");
    main_test::<sha3::Sha3_512>(&tests);
}

#[test]
fn sha3_shake128() {
    let tests = new_tests!("sha3_shake128/test1",
                           "sha3_shake128/test2",
                           "sha3_shake128/test3",
                           "sha3_shake128/test4",
                           "sha3_shake128/test5",
                           "sha3_shake128/test6",
                           "sha3_shake128/test7",
                           "sha3_shake128/test8",
                           "sha3_shake128/test9",
                           "sha3_shake128/test10",
                           "sha3_shake128/test11",
                           "sha3_shake128/test12",
                           "sha3_shake128/test13",
                           "sha3_shake128/test14",
                           "sha3_shake128/test15",
                           "sha3_shake128/test16",
                           "sha3_shake128/test17",
                           "sha3_shake128/test18",
                           "sha3_shake128/test19",
                           "sha3_shake128/test20",
                           "sha3_shake128/test21",
                           "sha3_shake128/test22",
                           "sha3_shake128/test23",
                           "sha3_shake128/test24",
                           "sha3_shake128/test25",
                           "sha3_shake128/test26",
                           "sha3_shake128/test27",
                           "sha3_shake128/test28",
                           "sha3_shake128/test29",
                           "sha3_shake128/test30",
                           "sha3_shake128/test31",
                           "sha3_shake128/test32",
                           "sha3_shake128/test33",
                           "sha3_shake128/test34",
                           "sha3_shake128/test35",
                           "sha3_shake128/test36",
                           "sha3_shake128/test37",
                           "sha3_shake128/test38",
                           "sha3_shake128/test39",
                           "sha3_shake128/test40",
                           "sha3_shake128/test41",
                           "sha3_shake128/test42",
                           "sha3_shake128/test43",
                           "sha3_shake128/test44",
                           "sha3_shake128/test45",
                           "sha3_shake128/test46",
                           "sha3_shake128/test47",
                           "sha3_shake128/test48",
                           "sha3_shake128/test49",
                           "sha3_shake128/test50",
                           "sha3_shake128/test51",
                           "sha3_shake128/test52",
                           "sha3_shake128/test53",
                           "sha3_shake128/test54",
                           "sha3_shake128/test55",
                           "sha3_shake128/test56",
                           "sha3_shake128/test57",
                           "sha3_shake128/test58",
                           "sha3_shake128/test59",
                           "sha3_shake128/test60",
                           "sha3_shake128/test61",
                           "sha3_shake128/test62",
                           "sha3_shake128/test63",
                           "sha3_shake128/test64",
                           "sha3_shake128/test65",
                           "sha3_shake128/test66",
                           "sha3_shake128/test67",
                           "sha3_shake128/test68",
                           "sha3_shake128/test69",
                           "sha3_shake128/test70",
                           "sha3_shake128/test71",
                           "sha3_shake128/test72",
                           "sha3_shake128/test73",
                           "sha3_shake128/test74",
                           "sha3_shake128/test75",
                           "sha3_shake128/test76",
                           "sha3_shake128/test77",
                           "sha3_shake128/test78",
                           "sha3_shake128/test79",
                           "sha3_shake128/test80",
                           "sha3_shake128/test81",
                           "sha3_shake128/test82",
                           "sha3_shake128/test83",
                           "sha3_shake128/test84",
                           "sha3_shake128/test85",
                           "sha3_shake128/test86",
                           "sha3_shake128/test87",
                           "sha3_shake128/test88",
                           "sha3_shake128/test89",
                           "sha3_shake128/test90",
                           "sha3_shake128/test91",
                           "sha3_shake128/test92",
                           "sha3_shake128/test93",
                           "sha3_shake128/test94",
                           "sha3_shake128/test95",
                           "sha3_shake128/test96",
                           "sha3_shake128/test97",
                           "sha3_shake128/test98",
                           "sha3_shake128/test99",
                           "sha3_shake128/test100",
                           "sha3_shake128/test101",
                           "sha3_shake128/test102",
                           "sha3_shake128/test103",
                           "sha3_shake128/test104",
                           "sha3_shake128/test105",
                           "sha3_shake128/test106",
                           "sha3_shake128/test107",
                           "sha3_shake128/test108",
                           "sha3_shake128/test109",
                           "sha3_shake128/test110",
                           "sha3_shake128/test111",
                           "sha3_shake128/test112",
                           "sha3_shake128/test113",
                           "sha3_shake128/test114",
                           "sha3_shake128/test115",
                           "sha3_shake128/test116",
                           "sha3_shake128/test117",
                           "sha3_shake128/test118",
                           "sha3_shake128/test119",
                           "sha3_shake128/test120",
                           "sha3_shake128/test121",
                           "sha3_shake128/test122",
                           "sha3_shake128/test123",
                           "sha3_shake128/test124",
                           "sha3_shake128/test125",
                           "sha3_shake128/test126",
                           "sha3_shake128/test127",
                           "sha3_shake128/test128",
                           "sha3_shake128/test129",
                           "sha3_shake128/test130",
                           "sha3_shake128/test131",
                           "sha3_shake128/test132",
                           "sha3_shake128/test133",
                           "sha3_shake128/test134",
                           "sha3_shake128/test135",
                           "sha3_shake128/test136",
                           "sha3_shake128/test137",
                           "sha3_shake128/test138",
                           "sha3_shake128/test139",
                           "sha3_shake128/test140",
                           "sha3_shake128/test141",
                           "sha3_shake128/test142",
                           "sha3_shake128/test143",
                           "sha3_shake128/test144",
                           "sha3_shake128/test145",
                           "sha3_shake128/test146",
                           "sha3_shake128/test147",
                           "sha3_shake128/test148",
                           "sha3_shake128/test149",
                           "sha3_shake128/test150",
                           "sha3_shake128/test151",
                           "sha3_shake128/test152",
                           "sha3_shake128/test153",
                           "sha3_shake128/test154",
                           "sha3_shake128/test155",
                           "sha3_shake128/test156",
                           "sha3_shake128/test157",
                           "sha3_shake128/test158",
                           "sha3_shake128/test159",
                           "sha3_shake128/test160",
                           "sha3_shake128/test161",
                           "sha3_shake128/test162",
                           "sha3_shake128/test163",
                           "sha3_shake128/test164",
                           "sha3_shake128/test165",
                           "sha3_shake128/test166",
                           "sha3_shake128/test167",
                           "sha3_shake128/test168",
                           "sha3_shake128/test169",
                           "sha3_shake128/test170",
                           "sha3_shake128/test171",
                           "sha3_shake128/test172",
                           "sha3_shake128/test173",
                           "sha3_shake128/test174",
                           "sha3_shake128/test175",
                           "sha3_shake128/test176",
                           "sha3_shake128/test177",
                           "sha3_shake128/test178",
                           "sha3_shake128/test179",
                           "sha3_shake128/test180",
                           "sha3_shake128/test181",
                           "sha3_shake128/test182",
                           "sha3_shake128/test183",
                           "sha3_shake128/test184",
                           "sha3_shake128/test185",
                           "sha3_shake128/test186",
                           "sha3_shake128/test187",
                           "sha3_shake128/test188",
                           "sha3_shake128/test189",
                           "sha3_shake128/test190",
                           "sha3_shake128/test191",
                           "sha3_shake128/test192",
                           "sha3_shake128/test193",
                           "sha3_shake128/test194",
                           "sha3_shake128/test195",
                           "sha3_shake128/test196",
                           "sha3_shake128/test197",
                           "sha3_shake128/test198",
                           "sha3_shake128/test199",
                           "sha3_shake128/test200",
                           "sha3_shake128/test201",
                           "sha3_shake128/test202",
                           "sha3_shake128/test203",
                           "sha3_shake128/test204",
                           "sha3_shake128/test205",
                           "sha3_shake128/test206",
                           "sha3_shake128/test207",
                           "sha3_shake128/test208",
                           "sha3_shake128/test209",
                           "sha3_shake128/test210",
                           "sha3_shake128/test211",
                           "sha3_shake128/test212",
                           "sha3_shake128/test213",
                           "sha3_shake128/test214",
                           "sha3_shake128/test215",
                           "sha3_shake128/test216",
                           "sha3_shake128/test217",
                           "sha3_shake128/test218",
                           "sha3_shake128/test219",
                           "sha3_shake128/test220",
                           "sha3_shake128/test221",
                           "sha3_shake128/test222",
                           "sha3_shake128/test223",
                           "sha3_shake128/test224",
                           "sha3_shake128/test225",
                           "sha3_shake128/test226",
                           "sha3_shake128/test227",
                           "sha3_shake128/test228",
                           "sha3_shake128/test229",
                           "sha3_shake128/test230",
                           "sha3_shake128/test231",
                           "sha3_shake128/test232",
                           "sha3_shake128/test233",
                           "sha3_shake128/test234",
                           "sha3_shake128/test235",
                           "sha3_shake128/test236",
                           "sha3_shake128/test237",
                           "sha3_shake128/test238",
                           "sha3_shake128/test239",
                           "sha3_shake128/test240",
                           "sha3_shake128/test241",
                           "sha3_shake128/test242",
                           "sha3_shake128/test243",
                           "sha3_shake128/test244",
                           "sha3_shake128/test245",
                           "sha3_shake128/test246",
                           "sha3_shake128/test247",
                           "sha3_shake128/test248",
                           "sha3_shake128/test249",
                           "sha3_shake128/test250",
                           "sha3_shake128/test251",
                           "sha3_shake128/test252",
                           "sha3_shake128/test253",
                           "sha3_shake128/test254",
                           "sha3_shake128/test255",
                           "sha3_shake128/test256");
    variable_test::<sha3::Shake128>(&tests);
}

#[test]
fn sha3_shake256() {
    let tests = new_tests!("sha3_shake256/test1",
                           "sha3_shake256/test2",
                           "sha3_shake256/test3",
                           "sha3_shake256/test4",
                           "sha3_shake256/test5",
                           "sha3_shake256/test6",
                           "sha3_shake256/test7",
                           "sha3_shake256/test8",
                           "sha3_shake256/test9",
                           "sha3_shake256/test10",
                           "sha3_shake256/test11",
                           "sha3_shake256/test12",
                           "sha3_shake256/test13",
                           "sha3_shake256/test14",
                           "sha3_shake256/test15",
                           "sha3_shake256/test16",
                           "sha3_shake256/test17",
                           "sha3_shake256/test18",
                           "sha3_shake256/test19",
                           "sha3_shake256/test20",
                           "sha3_shake256/test21",
                           "sha3_shake256/test22",
                           "sha3_shake256/test23",
                           "sha3_shake256/test24",
                           "sha3_shake256/test25",
                           "sha3_shake256/test26",
                           "sha3_shake256/test27",
                           "sha3_shake256/test28",
                           "sha3_shake256/test29",
                           "sha3_shake256/test30",
                           "sha3_shake256/test31",
                           "sha3_shake256/test32",
                           "sha3_shake256/test33",
                           "sha3_shake256/test34",
                           "sha3_shake256/test35",
                           "sha3_shake256/test36",
                           "sha3_shake256/test37",
                           "sha3_shake256/test38",
                           "sha3_shake256/test39",
                           "sha3_shake256/test40",
                           "sha3_shake256/test41",
                           "sha3_shake256/test42",
                           "sha3_shake256/test43",
                           "sha3_shake256/test44",
                           "sha3_shake256/test45",
                           "sha3_shake256/test46",
                           "sha3_shake256/test47",
                           "sha3_shake256/test48",
                           "sha3_shake256/test49",
                           "sha3_shake256/test50",
                           "sha3_shake256/test51",
                           "sha3_shake256/test52",
                           "sha3_shake256/test53",
                           "sha3_shake256/test54",
                           "sha3_shake256/test55",
                           "sha3_shake256/test56",
                           "sha3_shake256/test57",
                           "sha3_shake256/test58",
                           "sha3_shake256/test59",
                           "sha3_shake256/test60",
                           "sha3_shake256/test61",
                           "sha3_shake256/test62",
                           "sha3_shake256/test63",
                           "sha3_shake256/test64",
                           "sha3_shake256/test65",
                           "sha3_shake256/test66",
                           "sha3_shake256/test67",
                           "sha3_shake256/test68",
                           "sha3_shake256/test69",
                           "sha3_shake256/test70",
                           "sha3_shake256/test71",
                           "sha3_shake256/test72",
                           "sha3_shake256/test73",
                           "sha3_shake256/test74",
                           "sha3_shake256/test75",
                           "sha3_shake256/test76",
                           "sha3_shake256/test77",
                           "sha3_shake256/test78",
                           "sha3_shake256/test79",
                           "sha3_shake256/test80",
                           "sha3_shake256/test81",
                           "sha3_shake256/test82",
                           "sha3_shake256/test83",
                           "sha3_shake256/test84",
                           "sha3_shake256/test85",
                           "sha3_shake256/test86",
                           "sha3_shake256/test87",
                           "sha3_shake256/test88",
                           "sha3_shake256/test89",
                           "sha3_shake256/test90",
                           "sha3_shake256/test91",
                           "sha3_shake256/test92",
                           "sha3_shake256/test93",
                           "sha3_shake256/test94",
                           "sha3_shake256/test95",
                           "sha3_shake256/test96",
                           "sha3_shake256/test97",
                           "sha3_shake256/test98",
                           "sha3_shake256/test99",
                           "sha3_shake256/test100",
                           "sha3_shake256/test101",
                           "sha3_shake256/test102",
                           "sha3_shake256/test103",
                           "sha3_shake256/test104",
                           "sha3_shake256/test105",
                           "sha3_shake256/test106",
                           "sha3_shake256/test107",
                           "sha3_shake256/test108",
                           "sha3_shake256/test109",
                           "sha3_shake256/test110",
                           "sha3_shake256/test111",
                           "sha3_shake256/test112",
                           "sha3_shake256/test113",
                           "sha3_shake256/test114",
                           "sha3_shake256/test115",
                           "sha3_shake256/test116",
                           "sha3_shake256/test117",
                           "sha3_shake256/test118",
                           "sha3_shake256/test119",
                           "sha3_shake256/test120",
                           "sha3_shake256/test121",
                           "sha3_shake256/test122",
                           "sha3_shake256/test123",
                           "sha3_shake256/test124",
                           "sha3_shake256/test125",
                           "sha3_shake256/test126",
                           "sha3_shake256/test127",
                           "sha3_shake256/test128",
                           "sha3_shake256/test129",
                           "sha3_shake256/test130",
                           "sha3_shake256/test131",
                           "sha3_shake256/test132",
                           "sha3_shake256/test133",
                           "sha3_shake256/test134",
                           "sha3_shake256/test135",
                           "sha3_shake256/test136",
                           "sha3_shake256/test137",
                           "sha3_shake256/test138",
                           "sha3_shake256/test139",
                           "sha3_shake256/test140",
                           "sha3_shake256/test141",
                           "sha3_shake256/test142",
                           "sha3_shake256/test143",
                           "sha3_shake256/test144",
                           "sha3_shake256/test145",
                           "sha3_shake256/test146",
                           "sha3_shake256/test147",
                           "sha3_shake256/test148",
                           "sha3_shake256/test149",
                           "sha3_shake256/test150",
                           "sha3_shake256/test151",
                           "sha3_shake256/test152",
                           "sha3_shake256/test153",
                           "sha3_shake256/test154",
                           "sha3_shake256/test155",
                           "sha3_shake256/test156",
                           "sha3_shake256/test157",
                           "sha3_shake256/test158",
                           "sha3_shake256/test159",
                           "sha3_shake256/test160",
                           "sha3_shake256/test161",
                           "sha3_shake256/test162",
                           "sha3_shake256/test163",
                           "sha3_shake256/test164",
                           "sha3_shake256/test165",
                           "sha3_shake256/test166",
                           "sha3_shake256/test167",
                           "sha3_shake256/test168",
                           "sha3_shake256/test169",
                           "sha3_shake256/test170",
                           "sha3_shake256/test171",
                           "sha3_shake256/test172",
                           "sha3_shake256/test173",
                           "sha3_shake256/test174",
                           "sha3_shake256/test175",
                           "sha3_shake256/test176",
                           "sha3_shake256/test177",
                           "sha3_shake256/test178",
                           "sha3_shake256/test179",
                           "sha3_shake256/test180",
                           "sha3_shake256/test181",
                           "sha3_shake256/test182",
                           "sha3_shake256/test183",
                           "sha3_shake256/test184",
                           "sha3_shake256/test185",
                           "sha3_shake256/test186",
                           "sha3_shake256/test187",
                           "sha3_shake256/test188",
                           "sha3_shake256/test189",
                           "sha3_shake256/test190",
                           "sha3_shake256/test191",
                           "sha3_shake256/test192",
                           "sha3_shake256/test193",
                           "sha3_shake256/test194",
                           "sha3_shake256/test195",
                           "sha3_shake256/test196",
                           "sha3_shake256/test197",
                           "sha3_shake256/test198",
                           "sha3_shake256/test199",
                           "sha3_shake256/test200",
                           "sha3_shake256/test201",
                           "sha3_shake256/test202",
                           "sha3_shake256/test203",
                           "sha3_shake256/test204",
                           "sha3_shake256/test205",
                           "sha3_shake256/test206",
                           "sha3_shake256/test207",
                           "sha3_shake256/test208",
                           "sha3_shake256/test209",
                           "sha3_shake256/test210",
                           "sha3_shake256/test211",
                           "sha3_shake256/test212",
                           "sha3_shake256/test213",
                           "sha3_shake256/test214",
                           "sha3_shake256/test215",
                           "sha3_shake256/test216",
                           "sha3_shake256/test217",
                           "sha3_shake256/test218",
                           "sha3_shake256/test219",
                           "sha3_shake256/test220",
                           "sha3_shake256/test221",
                           "sha3_shake256/test222",
                           "sha3_shake256/test223",
                           "sha3_shake256/test224",
                           "sha3_shake256/test225",
                           "sha3_shake256/test226",
                           "sha3_shake256/test227",
                           "sha3_shake256/test228",
                           "sha3_shake256/test229",
                           "sha3_shake256/test230",
                           "sha3_shake256/test231",
                           "sha3_shake256/test232",
                           "sha3_shake256/test233",
                           "sha3_shake256/test234",
                           "sha3_shake256/test235",
                           "sha3_shake256/test236",
                           "sha3_shake256/test237",
                           "sha3_shake256/test238",
                           "sha3_shake256/test239",
                           "sha3_shake256/test240",
                           "sha3_shake256/test241",
                           "sha3_shake256/test242",
                           "sha3_shake256/test243",
                           "sha3_shake256/test244",
                           "sha3_shake256/test245",
                           "sha3_shake256/test246",
                           "sha3_shake256/test247",
                           "sha3_shake256/test248",
                           "sha3_shake256/test249",
                           "sha3_shake256/test250",
                           "sha3_shake256/test251",
                           "sha3_shake256/test252",
                           "sha3_shake256/test253",
                           "sha3_shake256/test254",
                           "sha3_shake256/test255",
                           "sha3_shake256/test256");
    variable_test::<sha3::Shake256>(&tests);
}
